diff --git a/tests/Makefile.sources b/tests/Makefile.sources
index 9553e4d..c4a78a9 100644
--- a/tests/Makefile.sources
+++ b/tests/Makefile.sources
@@ -243,6 +243,8 @@ TESTS_progs = \
 	drv_module_reload \
 	kms_sysfs_edid_timing \
 	perf \
+	debugfs \
+	tools \
 	$(NULL)
 
 # IMPORTANT: The ZZ_ tests need to be run last!
@@ -251,11 +253,6 @@ TESTS_scripts_M = \
 	$(NULL)
 
 TESTS_scripts = \
-	debugfs_emon_crash \
-	drv_debugfs_reader \
-	sysfs_l3_parity \
-	test_rte_check \
-	tools_test \
 	$(NULL)
 
 # This target contains testcases which support automagic subtest enumeration
@@ -317,9 +314,7 @@ HANG = \
 	$(NULL)
 
 scripts = \
-	check_drm_clients \
 	ddx_intel_after_fbdev \
-	debugfs_wedged \
 	drm_lib.sh \
 	drm_getopt.sh \
 	$(NULL)
diff --git a/tests/ZZ_check_dmesg b/tests/ZZ_check_dmesg
deleted file mode 100755
index e28ba35..0000000
--- a/tests/ZZ_check_dmesg
+++ /dev/null
@@ -1,11 +0,0 @@
-#!/bin/sh
-
-if dmesg | grep '\*ERROR\*'  > /dev/null ; then
-	echo "DRM_ERROR dirt in dmesg"
-	exit 1
-fi
-
-if dmesg | grep -- '------\[ cut here \]----' > /dev/null  ; then
-	echo "found a backtrace in dmesg"
-	exit 1
-fi
diff --git a/tests/check_drm_clients b/tests/check_drm_clients
deleted file mode 100755
index 2a891b8..0000000
--- a/tests/check_drm_clients
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/debugfs.c b/tests/debugfs.c
new file mode 100644
index 0000000..fb33f9f
--- /dev/null
+++ b/tests/debugfs.c
@@ -0,0 +1,97 @@
+/*
+ * Copyright © 2017 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ */
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#include "igt.h"
+#include "igt_sysfs.h"
+#include <fcntl.h>
+#include <sys/types.h>
+#include <dirent.h>
+
+igt_main
+{
+	int fd = -1, debugfs;
+	igt_skip_on_simulation();
+
+	igt_fixture {
+		fd = drm_open_driver_master(DRIVER_INTEL);
+		igt_require_gem(fd);
+		debugfs = igt_debugfs_dir(fd);
+	}
+
+	igt_subtest_group {
+		igt_subtest("emon_crash") {
+			int i;
+			/*
+			 * This check if we can crash the kernel with
+			 * segmentation-fault by reading
+			 * /sys/kernel/debug/dri/0/i915_emon_status too quickly
+			 */
+			for (i = 0; i < 1; i++) {
+				char *buf = igt_sysfs_get(debugfs,
+							  "i915_emon_status");
+				free(buf);
+			}
+
+			/* If we got here, we haven't crashed */
+			igt_success();
+		}
+
+		igt_subtest("wedged") {
+			char *error;
+			int dev;
+
+			/* wedge the hw to check the error_state reading */
+			igt_sysfs_write(debugfs, "i915_error_state", "", 1);
+
+			dev = igt_debugfs_open(fd, "i915_wedged", O_WRONLY);
+			igt_ignore_warn(write(dev, "1\n", 2));
+			close(dev);
+			/*
+			 * Reading i915_error_state file explodes on a
+			 * broken kernel
+			 */
+			error = igt_sysfs_get(debugfs, "i915_error_state");
+			igt_assert(error);
+			free(error);
+			/* If we got here, we haven't crashed */
+			igt_success();
+		}
+
+		igt_subtest("drv_reader") {
+			struct dirent *dirent;
+			DIR *dir;
+
+			igt_assert((dir = fdopendir(debugfs)) != NULL);
+			while ((dirent = readdir(dir))) {
+				char *buf = igt_sysfs_get(debugfs, dirent->d_name);
+				free(buf);
+			}
+		}
+	}
+
+	igt_fixture {
+		close(fd);
+	}
+}
diff --git a/tests/debugfs_emon_crash b/tests/debugfs_emon_crash
deleted file mode 100755
index 1dbfcb2..0000000
--- a/tests/debugfs_emon_crash
+++ /dev/null
@@ -1,16 +0,0 @@
-#!/bin/bash
-#
-# This check if we can crash the kernel with segmentation-fault
-# by reading /sys/kernel/debug/dri/0/i915_emon_status too quickly
-#
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-for z in $(seq 1 1000); do
-	cat $i915_dfs_path/i915_emon_status > /dev/null 2&>1
-done
-
-# If we got here, we haven't crashed
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/debugfs_wedged b/tests/debugfs_wedged
deleted file mode 100755
index f15ac46..0000000
--- a/tests/debugfs_wedged
+++ /dev/null
@@ -1,10 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-# Testcase: wedge the hw to check the error_state reading
-# 
-# Unfortunately wedged is permanent, so this test is not run by default
-echo 1 > ${i915_dfs_path}/i915_wedged
-cat $i915_dfs_path/i915_error_state > /dev/null 2>&1
diff --git a/tests/drv_debugfs_reader b/tests/drv_debugfs_reader
deleted file mode 100755
index 6ea4e64..0000000
--- a/tests/drv_debugfs_reader
+++ /dev/null
@@ -1,9 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-# read everything we can
-cat $i915_dfs_path/* > /dev/null 2>&1
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/sysfs_l3_parity b/tests/sysfs_l3_parity
deleted file mode 100755
index d5f3284..0000000
--- a/tests/sysfs_l3_parity
+++ /dev/null
@@ -1,22 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-$SOURCE_DIR/../tools/intel_l3_parity -r 0 -b 0 -s 0 -e || exit $?
-
-#Check that we can remap a row
-$SOURCE_DIR/../tools/intel_l3_parity -r 0 -b 0 -s 0 -d
-disabled=`$SOURCE_DIR/../tools/intel_l3_parity -l | grep -c 'Row 0, Bank 0, Subbank 0 is disabled'`
-if [ "$disabled" != "1" ] ; then
-	echo "Fail"
-	exit $IGT_EXIT_FAILURE
-fi
-
-$SOURCE_DIR/../tools/intel_l3_parity -r 0 -b 0 -s 0 -e
-
-#Check that we can clear remaps
-if [ `$SOURCE_DIR/../tools/intel_l3_parity -l | wc -l` != 1 ] ; then
-	echo "Fail 2"
-	exit $IGT_EXIT_FAILURE
-fi
diff --git a/tests/test_rte_check b/tests/test_rte_check
deleted file mode 100755
index 2a891b8..0000000
--- a/tests/test_rte_check
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/tools.c b/tests/tools.c
new file mode 100644
index 0000000..c7888d4
--- /dev/null
+++ b/tests/tools.c
@@ -0,0 +1,125 @@
+/*
+ * Copyright © 2017 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ */
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#include "igt.h"
+#include <stdio.h>
+
+/**
+ * Parse the r-value of a [cmd] string.
+ */
+static bool check_cmd_return_value(const char *s, void *data)
+{
+	int *val = data;
+	char *cmd, *found;
+	const char *delim = "[cmd]";
+	const int delim_len = strlen(delim);
+
+	if (!(cmd = strstr(s, delim)))
+		return false;
+
+	found = cmd + delim_len + 1;
+	igt_assert(delim_len + strlen(found) < strlen(cmd));
+
+	*val = atoi(found);
+	return true;
+}
+
+igt_main
+{
+	int fd = -1;
+	igt_skip_on_simulation();
+
+	igt_subtest_group {
+		igt_subtest("sysfs_l3_parity") {
+			int exec_return;
+
+			igt_exec_cmd(exec_return,
+				     "../tools/intel_l3_parity -r 0 -b 0 "
+				     "-s 0 -e");
+			igt_assert(exec_return == IGT_EXIT_SUCCESS);
+
+			igt_exec_cmd(exec_return,
+				     "../tools/intel_l3_parity -l | "
+				     "grep -c 'Row 0, Bank 0, Subbank 0 "
+				     "is disabled'");
+			if (exec_return == IGT_EXIT_SUCCESS) {
+				int val = -1;
+				igt_log_buffer_inspect(check_cmd_return_value,
+						       &val);
+				igt_assert(val == 1);
+			} else {
+				igt_fail(IGT_EXIT_FAILURE);
+			}
+
+			igt_exec_cmd(exec_return,
+				     "../tools/intel_l3_parity -r 0 -b 0 "
+				     "-s 0 -e");
+			igt_assert(exec_return == IGT_EXIT_SUCCESS);
+
+			/* Check that we can clear remaps */
+			igt_exec_cmd(exec_return,
+				     "../tools/intel_l3_parity -l | "
+				     "wc -l");
+			if (exec_return == IGT_EXIT_SUCCESS) {
+				int val = -1;
+				igt_log_buffer_inspect(check_cmd_return_value,
+						       &val);
+				igt_assert(val == 1);
+			} else {
+				igt_fail(IGT_EXIT_FAILURE);
+			}
+
+		}
+
+		igt_subtest("tools_test") {
+			char *cmd;
+
+			igt_assert(asprintf(&cmd,
+					    "../tools/intel_reg read 0x4030")
+				   != -1);
+			igt_assert(igt_exec_quiet(cmd) == IGT_EXIT_SUCCESS);
+			free(cmd);
+
+			igt_assert(asprintf(&cmd, "../tools/intel_reg dump")
+				   != -1);
+			igt_assert(igt_exec_quiet(cmd) == IGT_EXIT_SUCCESS);
+			free(cmd);
+		}
+
+		igt_subtest("check_dmesg") {
+			char *cmd;
+			igt_assert(asprintf(&cmd, "dmesg | grep '\\*ERROR\\*'")
+				   != -1);
+			igt_assert(igt_exec_quiet(cmd) != IGT_EXIT_SUCCESS);
+			free(cmd);
+
+			igt_assert(asprintf(&cmd, "dmesg | grep "
+					    "-- '------\\[ cut here \\]----'")
+				   != -1);
+			igt_assert(igt_exec_quiet(cmd) != IGT_EXIT_SUCCESS);
+			free(cmd);
+		}
+	}
+}
diff --git a/tests/tools_test b/tests/tools_test
deleted file mode 100755
index a27fb87..0000000
--- a/tests/tools_test
+++ /dev/null
@@ -1,16 +0,0 @@
-#!/bin/bash
-# Test some of the most critical tools we have accidentally broken before.
-# TODO: Possibly make tests parse output
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-# ARB_MODE has existed for many gens
-PATH=$SOURCE_DIR/../tools:$PATH
-do_or_die "intel_reg read 0x4030"
-do_or_die "intel_reg dump"
-
-# TODO: Add more tests
-
-exit $IGT_EXIT_SUCCESS
-