diff --git a/tests/Makefile.sources b/tests/Makefile.sources
index dafb028..c40b2ab 100644
--- a/tests/Makefile.sources
+++ b/tests/Makefile.sources
@@ -231,6 +231,7 @@ TESTS_progs = \
 	template \
 	vgem_basic \
 	vgem_slow \
+	debugfs_test \
 	$(NULL)
 
 TESTS_progs_X = \
@@ -238,8 +239,6 @@ TESTS_progs_X = \
     $(NULL)
 
 TESTS_scripts = \
-	debugfs_emon_crash \
-	drv_debugfs_reader \
 	sysfs_l3_parity \
 	test_rte_check \
 	tools_test \
@@ -276,7 +275,6 @@ HANG = \
 scripts = \
 	check_drm_clients \
 	ddx_intel_after_fbdev \
-	debugfs_wedged \
 	drm_lib.sh \
 	drm_getopt.sh \
 	$(NULL)
diff --git a/tests/debugfs_emon_crash b/tests/debugfs_emon_crash
deleted file mode 100755
index 1dbfcb2..0000000
--- a/tests/debugfs_emon_crash
+++ /dev/null
@@ -1,16 +0,0 @@
-#!/bin/bash
-#
-# This check if we can crash the kernel with segmentation-fault
-# by reading /sys/kernel/debug/dri/0/i915_emon_status too quickly
-#
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-for z in $(seq 1 1000); do
-	cat $i915_dfs_path/i915_emon_status > /dev/null 2&>1
-done
-
-# If we got here, we haven't crashed
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/debugfs_test.c b/tests/debugfs_test.c
new file mode 100644
index 0000000..6a4b871
--- /dev/null
+++ b/tests/debugfs_test.c
@@ -0,0 +1,98 @@
+/*
+ * Copyright © 2017 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ */
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#include "igt.h"
+#include "igt_sysfs.h"
+#include <fcntl.h>
+#include <sys/types.h>
+#include <dirent.h>
+
+static void read_and_discard_sysfs_entry(int path_fd)
+{
+	struct dirent *dirent;
+	DIR *dir;
+
+	dir = fdopendir(path_fd);
+	if (!dir)
+		return;
+
+	while ((dirent = readdir(dir))) {
+		if (!strcmp(dirent->d_name, ".") ||
+		    !strcmp(dirent->d_name, ".."))
+			continue;
+		if (dirent->d_type == DT_DIR) {
+			int sub_fd = -1;
+			igt_assert((sub_fd =
+				    openat(path_fd, dirent->d_name, O_RDONLY |
+					   O_DIRECTORY)) > 0);
+			read_and_discard_sysfs_entry(sub_fd);
+			close(sub_fd);
+		} else {
+			char *buf = igt_sysfs_get(path_fd, dirent->d_name);
+			igt_assert(buf);
+			free(buf);
+		}
+	}
+	closedir(dir);
+}
+
+igt_main
+{
+	int fd = -1, debugfs;
+	igt_skip_on_simulation();
+
+	igt_fixture {
+		fd = drm_open_driver_master(DRIVER_INTEL);
+		igt_require_gem(fd);
+		debugfs = igt_debugfs_dir(fd);
+	}
+
+	igt_subtest("drv_reader") {
+		read_and_discard_sysfs_entry(debugfs);
+	}
+
+	igt_subtest("emon_crash") {
+		int i;
+		/*
+		 * This check if we can crash the kernel with
+		 * segmentation-fault by reading
+		 * /sys/kernel/debug/dri/0/i915_emon_status too quickly
+		 */
+		for (i = 0; i < 1000; i++) {
+			char *buf = igt_sysfs_get(debugfs,
+						  "i915_emon_status");
+			igt_assert(buf);
+			free(buf);
+		}
+
+		/* If we got here, we haven't crashed */
+		igt_success();
+	}
+
+	igt_fixture {
+		close(debugfs);
+		close(fd);
+	}
+}
diff --git a/tests/debugfs_wedged b/tests/debugfs_wedged
deleted file mode 100755
index f15ac46..0000000
--- a/tests/debugfs_wedged
+++ /dev/null
@@ -1,10 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-# Testcase: wedge the hw to check the error_state reading
-# 
-# Unfortunately wedged is permanent, so this test is not run by default
-echo 1 > ${i915_dfs_path}/i915_wedged
-cat $i915_dfs_path/i915_error_state > /dev/null 2>&1
diff --git a/tests/drv_debugfs_reader b/tests/drv_debugfs_reader
deleted file mode 100755
index 6ea4e64..0000000
--- a/tests/drv_debugfs_reader
+++ /dev/null
@@ -1,9 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-# read everything we can
-cat $i915_dfs_path/* > /dev/null 2>&1
-
-exit $IGT_EXIT_SUCCESS