diff --git a/tests/Makefile.sources b/tests/Makefile.sources
index c40b2ab..b0b2f22 100644
--- a/tests/Makefile.sources
+++ b/tests/Makefile.sources
@@ -232,18 +232,13 @@ TESTS_progs = \
 	vgem_basic \
 	vgem_slow \
 	debugfs_test \
+	tools_test \
 	$(NULL)
 
 TESTS_progs_X = \
     gem_concurrent_all \
     $(NULL)
 
-TESTS_scripts = \
-	sysfs_l3_parity \
-	test_rte_check \
-	tools_test \
-	$(NULL)
-
 kernel_tests = \
 	$(TESTS_progs) \
 	$(TESTS_scripts) \
@@ -273,7 +268,6 @@ HANG = \
 	$(NULL)
 
 scripts = \
-	check_drm_clients \
 	ddx_intel_after_fbdev \
 	drm_lib.sh \
 	drm_getopt.sh \
diff --git a/tests/ZZ_check_dmesg b/tests/ZZ_check_dmesg
deleted file mode 100755
index e28ba35..0000000
--- a/tests/ZZ_check_dmesg
+++ /dev/null
@@ -1,11 +0,0 @@
-#!/bin/sh
-
-if dmesg | grep '\*ERROR\*'  > /dev/null ; then
-	echo "DRM_ERROR dirt in dmesg"
-	exit 1
-fi
-
-if dmesg | grep -- '------\[ cut here \]----' > /dev/null  ; then
-	echo "found a backtrace in dmesg"
-	exit 1
-fi
diff --git a/tests/check_drm_clients b/tests/check_drm_clients
deleted file mode 100755
index 2a891b8..0000000
--- a/tests/check_drm_clients
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/sysfs_l3_parity b/tests/sysfs_l3_parity
deleted file mode 100755
index d5f3284..0000000
--- a/tests/sysfs_l3_parity
+++ /dev/null
@@ -1,22 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-$SOURCE_DIR/../tools/intel_l3_parity -r 0 -b 0 -s 0 -e || exit $?
-
-#Check that we can remap a row
-$SOURCE_DIR/../tools/intel_l3_parity -r 0 -b 0 -s 0 -d
-disabled=`$SOURCE_DIR/../tools/intel_l3_parity -l | grep -c 'Row 0, Bank 0, Subbank 0 is disabled'`
-if [ "$disabled" != "1" ] ; then
-	echo "Fail"
-	exit $IGT_EXIT_FAILURE
-fi
-
-$SOURCE_DIR/../tools/intel_l3_parity -r 0 -b 0 -s 0 -e
-
-#Check that we can clear remaps
-if [ `$SOURCE_DIR/../tools/intel_l3_parity -l | wc -l` != 1 ] ; then
-	echo "Fail 2"
-	exit $IGT_EXIT_FAILURE
-fi
diff --git a/tests/test_rte_check b/tests/test_rte_check
deleted file mode 100755
index 2a891b8..0000000
--- a/tests/test_rte_check
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/bin/bash
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-exit $IGT_EXIT_SUCCESS
diff --git a/tests/tools_test b/tests/tools_test
deleted file mode 100755
index a27fb87..0000000
--- a/tests/tools_test
+++ /dev/null
@@ -1,16 +0,0 @@
-#!/bin/bash
-# Test some of the most critical tools we have accidentally broken before.
-# TODO: Possibly make tests parse output
-
-SOURCE_DIR="$( dirname "${BASH_SOURCE[0]}" )"
-. $SOURCE_DIR/drm_lib.sh
-
-# ARB_MODE has existed for many gens
-PATH=$SOURCE_DIR/../tools:$PATH
-do_or_die "intel_reg read 0x4030"
-do_or_die "intel_reg dump"
-
-# TODO: Add more tests
-
-exit $IGT_EXIT_SUCCESS
-
diff --git a/tests/tools_test.c b/tests/tools_test.c
new file mode 100644
index 0000000..b3f57db
--- /dev/null
+++ b/tests/tools_test.c
@@ -0,0 +1,146 @@
+/*
+ * Copyright © 2017 Intel Corporation
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the next
+ * paragraph) shall be included in all copies or substantial portions of the
+ * Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
+ * IN THE SOFTWARE.
+ */
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#include "igt.h"
+#include <stdio.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
+
+/**
+ * Parse the r-value of a [cmd] string.
+ */
+static bool check_cmd_return_value(const char *s, void *data)
+{
+	int *val = data;
+	char *cmd, *found;
+	const char *delim = "[cmd]";
+	const int delim_len = strlen(delim);
+
+	if (!(cmd = strstr(s, delim)))
+		return false;
+
+	found = cmd + delim_len + 1;
+	igt_assert(delim_len + strlen(found) < strlen(cmd));
+
+	*val = atoi(found);
+	return true;
+}
+
+static bool kmsg_check(const char *str)
+{
+	int fd;
+	FILE *file = NULL;
+
+	fd = open("/dev/kmsg", O_RDONLY | O_NONBLOCK);
+	if (fd != -1)
+		file = fdopen(fd, "r");
+	if (file) {
+		size_t len = 0;
+		char *line = NULL;
+		char *ret = NULL;
+
+		while (getline(&line, &len, file) != -1) {
+			if ((ret = strstr(line, str)) != NULL) {
+				break;
+			}
+		}
+		free(line);
+		fclose(file);
+		close(fd);
+		if (ret)
+			return true;
+	} else {
+		close(fd);
+		igt_warn("Unable to retrieve kernel log (from /dev/kmsg)\n");
+	}
+	return false;
+}
+
+igt_main
+{
+	int fd = -1;
+	igt_skip_on_simulation();
+
+	igt_subtest("sysfs_l3_parity") {
+		int exec_return;
+
+		igt_system_cmd(exec_return,
+			       "../tools/intel_l3_parity -r 0 -b 0 "
+			       "-s 0 -e");
+		igt_assert(exec_return == IGT_EXIT_SUCCESS);
+
+		igt_system_cmd(exec_return,
+			       "../tools/intel_l3_parity -l | "
+			       "grep -c 'Row 0, Bank 0, Subbank 0 "
+			       "is disabled'");
+		if (exec_return == IGT_EXIT_SUCCESS) {
+			int val = -1;
+			igt_log_buffer_inspect(check_cmd_return_value,
+					       &val);
+			igt_assert(val == 1);
+		} else {
+			igt_fail(IGT_EXIT_FAILURE);
+		}
+
+		igt_system_cmd(exec_return,
+			       "../tools/intel_l3_parity -r 0 -b 0 "
+			       "-s 0 -e");
+		igt_assert(exec_return == IGT_EXIT_SUCCESS);
+
+		/* Check that we can clear remaps */
+		igt_system_cmd(exec_return,
+			       "../tools/intel_l3_parity -l | "
+			       "wc -l");
+		if (exec_return == IGT_EXIT_SUCCESS) {
+			int val = -1;
+			igt_log_buffer_inspect(check_cmd_return_value,
+					       &val);
+			igt_assert(val == 1);
+		} else {
+			igt_fail(IGT_EXIT_FAILURE);
+		}
+	}
+
+	igt_subtest("tools_test") {
+		char *cmd;
+
+		igt_assert(asprintf(&cmd,
+				    "../tools/intel_reg read 0x4030")
+			   != -1);
+		igt_assert(igt_system_quiet(cmd) == IGT_EXIT_SUCCESS);
+		free(cmd);
+
+		igt_assert(asprintf(&cmd, "../tools/intel_reg dump")
+			   != -1);
+		igt_assert(igt_system_quiet(cmd) == IGT_EXIT_SUCCESS);
+		free(cmd);
+	}
+
+	igt_subtest("check_dmesg") {
+		igt_assert(!kmsg_check("*ERROR*"));
+		igt_assert(!kmsg_check("------[ cut here ]----"));
+	}
+}